<template>
  <dibs-layout ref="layout" page="lpp" layout="two-columns" :video="video">
    <template #aside-header
    ><div />
    <dibs-elem-lang-dropdown
    /></template>
    <template #aside-title>
      <!-- eslint-disable-next-line vue/no-v-html -->
      <h1 v-html="$t('page.lpp.title')" />
    </template>
    <template #content>
      <pre v-if="mode == 'debug'">{{ { lpp } }}</pre>
      <dibs-form-elem
      v-if="funds"
      hint="<ul>
        <li>Neosis :
          <ul>
            <li><pre>testuser1/iPension1</pre></li>
          </ul>
          <li>
            Star Fund :<ul>
              <li><pre>alice/alice</pre></li>
              <li><pre>beatrice/beatrice</pre></li>
              <li><pre>dan/dan</pre></li>
            </ul>
          </li>
        </li>
      </ul>"
      :label="$t('page.lpp.form.label')"
      name="lpp"
      >
      <dibs-form-row :element-count="1" :has-ending="true">
        <dibs-input-select-search
        id="lpp"
        v-model="lpp"
        :default="lpp"
        :options="Object.values(funds)"
        label="name"
        />
        <dibs-input-help @click="$refs['modal-lpp'].open()">
          {{ $t('commons.where_to_find') }}
        </dibs-input-help>
      </dibs-form-row>
    </dibs-form-elem>
    <dibs-elem-btn
    :label="$t('page.lpp.action')"
    picto="forward"
    :disabled="!formIsOk"
    @click="onSave"
    />
    <dibs-modal ref="modal-lpp">
      <template #title>{{ $t('page.lpp.modal.title') }}</template>
      <template #content>
        <!-- eslint-disable-next-line vue/no-v-html -->
        <p v-html="$t('page.lpp.modal.content')" />
      </template>
    </dibs-modal>
  </template>
</dibs-layout>
</template>

<script>
  export default {
    name: 'IndexPage',
    layout: 'dibs',
    data() {
      return {
        mode: this.$route.query.mode,
        video: this.$t('page.lpp.video'),
        funds: null,
        lpp: null,
        grantingWindow: null,
        grantingOk: false,
      }
    },
    computed: {
      formIsOk() {
        return !!this.lpp
      },
    },
    mounted() {
      this.init()
    },
    methods: {
      init() {
        this.$models.Loader().on()
        this.$models.User().checkConnectionStatus()

        window.addEventListener(
          'message',
          (msg) => {
            if (!this.grantingWindow) {
              return
            }
            const data = msg.data
            if (data === 'grant-is-okay') {
              this.$models.Loader().on()
              this.grantingWindow.close()
              this.grantingWindow = null
              this.grantingOk = true
              this.getPolicy()
            }
          },
          false
          )

        this.$models
        .OpenPK()
        .getRegistry()
        .then((registry) => {
          this.$models
          .OpenPK()
          .getSelection()
          .then((ids) => {
            if (ids && ids[0]) {
              this.lpp = Object.assign({}, registry[ids[0]])
            }
          })
          .finally(() => {
            this.funds = registry
            this.$models.Loader().off()
          })
        })
        .catch(() => {
          this.$models.Loader().off()
        })
      },
      error() {
        alert('Erreur lors de la sauvegarde de vos données')
      },
      getPolicy() {
        this.$models
        .OpenPK()
        .getPolicy()
        .then(() => {
          this.$router.push(this.localePath('/synthesis'))
        })
        .catch(() => {
          this.$models.Loader().off()
          alert('Erreur lors de la récupération de vos données')
        })
      },
      onSave() {
        this.$models.Loader().on()
        this.grantingOk = false
        this.$models
        .OpenPK()
        .saveSelection([this.lpp.id])
        .then(() => {
          this.startGranting()
        })
        .catch(() => {
          this.$models.Loader().off()
          this.$refs.layout.loadMe(true)
        })
      },
      startGranting() {
        this.grantingWindow = window.open(
          this.$config.dibsApiBasePath + '/openpk/user/pension-funds/tokens',
          '_blank'
          )
        this.$models.Loader().off()
      },
    },
  }
</script>
